
IF  EXISTS(select syscolumns.name  from syscolumns 
               left join sysobjects on syscolumns.id=sysobjects.id
               where syscolumns.name = 'cetron' and sysobjects.name='plantillas_puestos')
               drop table plantillas_puestos                
GO

IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'dbo.Plantillas_Puestos') and type = 'U')

			CREATE TABLE dbo.Plantillas_Puestos(
				empresa numeric(3, 0) NOT NULL,
				plantilla_id bigint NOT NULL,
				ocupacion int NOT NULL,
				cantidad int NULL,
				disponibles int NULL,
				clase char(2) NULL,
				horario int NULL,
				tiposal int NULL,
				sueldo decimal(12, 2) NULL,
				sindicato char(1) NULL,
				varia_imss decimal(8, 2) NULL,
				reqAutorizacion char(1) NULL,
				nivelAutorizacion int NULL,
				autorizador1 varchar(50) NULL,
				autorizador2 varchar(50) NULL,
				autorizador3 varchar(50) NULL,
				autorizador4 varchar(50) NULL,
				centro char(15) NOT NULL,
				tiponom int NULL,
			 CONSTRAINT PK_Plantillas_Puestos PRIMARY KEY CLUSTERED 
			(
				empresa ASC,
				plantilla_id ASC,
				ocupacion ASC,
				centro ASC
			)
			) 

			GO
			
go			


IF EXISTS ( SELECT
                name
            FROM
                dbo.sysobjects
            WHERE
                name = 'usuariosInsertaPerfilPlantillas' AND
                type = 'P' ) 
    DROP PROCEDURE dbo.usuariosInsertaPerfilPlantillas
GO

CREATE PROCEDURE dbo.usuariosInsertaPerfilPlantillas 
    WITH ENCRYPTION
AS 
     SET NOCOUNT ON
     SET DATEFORMAT MDY
     
     declare @existe int
     declare @idPerfil int
     
     select @existe=count(*) from sistema where sistema='PL'
     if @existe=0
		begin
		insert into sistema values ('PL','PLANTILLAS')
		end
     
     select @existe=count(*) from perfiles where sistema='PL'
    
	 if @existe=0
		begin
		 insert into perfiles values('Administrador de Plantillas','PL','{}','{}','N','N')

		 insert into funciones values ('PL', 'A' , 'Plantillas') 
		 insert into funciones values ('PL', 'B' , 'Boletinar Vacantes') 
		 insert into funciones values ('PL', 'C' , 'Proponer y Asignar') 
		 insert into funciones values ('PL', 'D' , 'Gestion y Avisos por Email') 
		 insert into funciones values ('PL', 'E' , 'Auditoria y Reportes') 
		 insert into funciones values ('PL', 'K' , 'Utilerias') 

		 insert into opciones values ('A1','PL', 'A', 'Nueva Plantilla') 
		 insert into opciones values ('A2','PL', 'A', 'Borrar Plantilla') 
		 insert into opciones values ('A3','PL', 'A', 'Agregar Centro') 
		 insert into opciones values ('A4','PL', 'A', 'Eliminar Centro') 
		 insert into opciones values ('A5','PL', 'A', 'Agregar Puesto') 
		 insert into opciones values ('A6','PL', 'A', 'Eliminar Puesto') 
		 insert into opciones values ('A7','PL', 'A', 'Guardar') 

		 insert into opciones values ('B1','PL', 'B', 'Enviar vacantes por email') 

		 insert into opciones values ('C1','PL', 'C', 'Agregar Empleados') 
		 insert into opciones values ('C2','PL', 'C', 'Agregar de la Bolsa de Trabajo') 
		 insert into opciones values ('C3','PL', 'C', 'Eliminar Propuestos') 
		 insert into opciones values ('C4','PL', 'C', 'Enviar propuestos para autorizacion') 

		 insert into opciones values ('D1','PL', 'D', 'Autorizar Propuestos') 
		 insert into opciones values ('D2','PL', 'D', 'Eliminar Autorizados') 
		 insert into opciones values ('D3','PL', 'D', 'Enviar Autorizados para Contratacion') 

		 insert into opciones values ('E1','PL', 'E', 'Generar Reporte') 

		 insert into opciones values ('K1','PL', 'K', 'Inicializar Plantilla') 
		 insert into opciones values ('K2','PL', 'K', 'Pueden ver Vacantes') 
		 insert into opciones values ('K3','PL', 'K', 'Autorizacion') 
		 insert into opciones values ('K4','PL', 'K', 'Configuracion Envio') 
		 insert into opciones values ('K5','PL', 'K', 'Configuracion Email')
		 		 		
		 Select @idPerfil=idperfil from perfiles 
         where descripcion='Administrador de Plantillas '
		 
	 	insert into perfil_funcion
        Select opciones.Funcion,opciones.Opcion,@idperfil
        From Opciones Where opciones.sistema = 'PL'   
        
        insert into perfil_usuarios(idperfil,usuario) values (@idperfil,'Administrador')                     
            
	end
		
GO

exec usuariosInsertaPerfilPlantillas

go



IF EXISTS ( SELECT
                name
            FROM
                dbo.sysobjects
            WHERE
                name = 'usuariosInsertaFuncionesOpcionesPlantillas' AND
                type = 'P' ) 
    DROP PROCEDURE dbo.usuariosInsertaFuncionesOpcionesPlantillas
GO

CREATE PROCEDURE dbo.usuariosInsertaFuncionesOpcionesPlantillas 
    WITH ENCRYPTION
AS 

BEGIN

     SET NOCOUNT ON
     SET DATEFORMAT MDY


	if not exists (select * from funciones where sistema='PL' and funcion='A' and descripcion='Plantillas')
		 insert into funciones values ('PL', 'A' , 'Plantillas') 
		 
	if not exists (select * from funciones where sistema='PL' and funcion='B' and descripcion='Boletinar Vacantes')		 
		 insert into funciones values ('PL', 'B' , 'Boletinar Vacantes') 
	
	if not exists (select * from funciones where sistema='PL' and funcion='C' and descripcion='Proponer y Asignar')
		 insert into funciones values ('PL', 'C' , 'Proponer y Asignar') 
		 
	if not exists (select * from funciones where sistema='PL' and funcion='D' and descripcion='Gestion y Avisos por Email')		 
		 insert into funciones values ('PL', 'D' , 'Gestion y Avisos por Email') 
		 
	if not exists (select * from funciones where sistema='PL' and funcion='E' and descripcion='Auditoria y Reportes')		 
		 insert into funciones values ('PL', 'E' , 'Auditoria y Reportes') 
	
	if not exists (select * from funciones where sistema='PL' and funcion='K' and descripcion='Utilerias')
		 insert into funciones values ('PL', 'K' , 'Utilerias') 


	if not exists (select * from OPCIONES where OPCION='A1' and sistema='PL' and funcion='A' and descripcion='Nueva Plantilla')
		 insert into opciones values ('A1','PL', 'A', 'Nueva Plantilla') 
	
	if not exists (select * from OPCIONES where OPCION='A2' and sistema='PL' and funcion='A' and descripcion='Borrar Plantilla')
		 insert into opciones values ('A2','PL', 'A', 'Borrar Plantilla') 
		 
	if not exists (select * from OPCIONES where OPCION='A3' and sistema='PL' and funcion='A' and descripcion='Agregar Centro')		 
		 insert into opciones values ('A3','PL', 'A', 'Agregar Centro') 
		 
	if not exists (select * from OPCIONES where OPCION='A4' and sistema='PL' and funcion='A' and descripcion='Eliminar Centro')		 
		 insert into opciones values ('A4','PL', 'A', 'Eliminar Centro') 
		 
	if not exists (select * from OPCIONES where OPCION='A5' and sistema='PL' and funcion='A' and descripcion='Agregar Puesto')		 
		 insert into opciones values ('A5','PL', 'A', 'Agregar Puesto') 
		 
	if not exists (select * from OPCIONES where OPCION='A6' and sistema='PL' and funcion='A' and descripcion='Eliminar Puesto')		 
		 insert into opciones values ('A6','PL', 'A', 'Eliminar Puesto') 
		 
	if not exists (select * from OPCIONES where OPCION='A7' and sistema='PL' and funcion='A' and descripcion='Guardar')		 
		 insert into opciones values ('A7','PL', 'A', 'Guardar') 
		 
	if not exists (select * from OPCIONES where OPCION='B1' and sistema='PL' and funcion='B' and descripcion='Enviar vacantes por email')		 
		 insert into opciones values ('B1','PL', 'B', 'Enviar vacantes por email') 

	if not exists (select * from OPCIONES where OPCION='C1' and sistema='PL' and funcion='C' and descripcion='Agregar Empleados')		 
		 insert into opciones values ('C1','PL', 'C', 'Agregar Empleados') 
		 
	if not exists (select * from OPCIONES where OPCION='C2' and sistema='PL' and funcion='C' and descripcion='Agregar de la Bolsa de Trabajo')				 
		 insert into opciones values ('C2','PL', 'C', 'Agregar de la Bolsa de Trabajo') 
	
	if not exists (select * from OPCIONES where OPCION='C3' and sistema='PL' and funcion='C' and descripcion='Eliminar Propuestos')	
		 insert into opciones values ('C3','PL', 'C', 'Eliminar Propuestos') 
		 
	if not exists (select * from OPCIONES where OPCION='C4' and sistema='PL' and funcion='C' and descripcion='Enviar propuestos para autorizacion')			 
		 insert into opciones values ('C4','PL', 'C', 'Enviar propuestos para autorizacion') 


	if not exists (select * from OPCIONES where OPCION='D1' and sistema='PL' and funcion='D' and descripcion='Autorizar Propuestos')			 
		 insert into opciones values ('D1','PL', 'D', 'Autorizar Propuestos') 
	
	if not exists (select * from OPCIONES where OPCION='D2' and sistema='PL' and funcion='D' and descripcion='Eliminar Autorizados')			 
		 insert into opciones values ('D2','PL', 'D', 'Eliminar Autorizados') 
		 
	if not exists (select * from OPCIONES where OPCION='D3' and sistema='PL' and funcion='D' and descripcion='Enviar Autorizados para Contratacion')			 		 
		 insert into opciones values ('D3','PL', 'D', 'Enviar Autorizados para Contratacion') 


	if not exists (select * from OPCIONES where OPCION='E1' and sistema='PL' and funcion='E' and descripcion='Generar Reporte')			 
		 insert into opciones values ('E1','PL', 'E', 'Generar Reporte') 


	if not exists (select * from OPCIONES where OPCION='K1' and sistema='PL' and funcion='K' and descripcion='Inicializar Plantilla')			 
		 insert into opciones values ('K1','PL', 'K', 'Inicializar Plantilla') 
		 
	if not exists (select * from OPCIONES where OPCION='K2' and sistema='PL' and funcion='K' and descripcion='Pueden ver Vacantes')			 		 
		 insert into opciones values ('K2','PL', 'K', 'Pueden ver Vacantes') 
	
	if not exists (select * from OPCIONES where OPCION='K3' and sistema='PL' and funcion='K' and descripcion='Autorizacion')			 
		 insert into opciones values ('K3','PL', 'K', 'Autorizacion') 
		 
	if not exists (select * from OPCIONES where OPCION='K4' and sistema='PL' and funcion='K' and descripcion='Configuracion Envio')			 		 
		 insert into opciones values ('K4','PL', 'K', 'Configuracion Envio') 
		 
	if not exists (select * from OPCIONES where OPCION='K5' and sistema='PL' and funcion='K' and descripcion='Configuracion Email')			 		 
		 insert into opciones values ('K5','PL', 'K', 'Configuracion Email')
		 
	END
GO
		 
exec usuariosInsertaFuncionesOpcionesPlantillas
go


IF  EXISTS (SELECT * FROM dbo.sysobjects 
                  WHERE id = OBJECT_ID(N'dbo.Refempleados860') AND 
                  parent_obj = OBJECT_ID(N'dbo.Plantilla_empleado')) 
                  ALTER TABLE dbo.Plantilla_empleado DROP CONSTRAINT Refempleados860
GO

IF  EXISTS (SELECT * FROM dbo.sysobjects 
                  WHERE id = OBJECT_ID(N'dbo.RefPlantillas859') 
                  AND parent_obj = OBJECT_ID(N'dbo.Plantilla_empleado'))
                  ALTER TABLE dbo.Plantilla_empleado DROP CONSTRAINT RefPlantillas859
GO

IF  EXISTS (SELECT * FROM dbo.sysobjects 
                  WHERE id = OBJECT_ID(N'dbo.Plantilla_empleado') 
                  AND type in (N'U'))
                  DROP TABLE dbo.Plantilla_empleado 
GO      

IF  EXISTS (SELECT * FROM dbo.sysobjects 
                  WHERE id = OBJECT_ID(N'dbo.Refempresas955') 
                  AND parent_obj = OBJECT_ID(N'dbo.Plantilla_Tipo'))
                  ALTER TABLE dbo.Plantilla_Tipo DROP CONSTRAINT Refempresas955 
GO

IF  EXISTS (SELECT * FROM dbo.sysobjects
                  WHERE id = OBJECT_ID(N'dbo.RefPlantilla_Tipo944') 
                  AND parent_obj = OBJECT_ID(N'dbo.Plantillas'))
                 ALTER TABLE dbo.Plantillas DROP CONSTRAINT RefPlantilla_Tipo944   
GO    

IF  EXISTS(select syscolumns.name  from syscolumns 
                   left join sysobjects on syscolumns.id=sysobjects.id 
                   where syscolumns.name = 'idtipo' and sysobjects.name='plantillas')
                   Alter table plantillas alter column idtipo char(1) 
GO     

update plantillas set idtipo='P' where idtipo='1' or idtipo='2'
GO

IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = 
                  OBJECT_ID(N'dbo.plantilla_Tipo') AND type in (N'U'))
                  DROP TABLE dbo.plantilla_Tipo  
GO

if not exists (select * from dbo.sysobjects 
                   where id = object_id(N'dbo.plantillas_vacanteve')
                   and OBJECTPROPERTY(id, N'IsUserTable') = 1)
                   CREATE TABLE dbo.plantillas_vacanteve(
                  	idempresa varchar(50) NOT NULL,
	               usuario varchar(30) NOT NULL,
                  CONSTRAINT PK_plantillas_vacanteve PRIMARY KEY CLUSTERED 
                  (
	               idempresa ASC,
	               usuario ASC
                  ) 
                  ) 
                  
GO

if not exists (select * from dbo.sysobjects  
                   where id = object_id(N'dbo.plantilla_propuestos') 
                   and OBJECTPROPERTY(id, N'IsUserTable') = 1) 
                  CREATE TABLE dbo.plantilla_propuestos( 
                 	empresa numeric(3, 0) NOT NULL, 
	                 idPlantilla bigint NOT NULL, 
	                 ocupacion int NOT NULL, 
	                 tipo char(1)  NOT NULL, 
	                 clave numeric(8, 0) NOT NULL, 
	                 autorizado char(1) NULL, 
	                 tiponom int NULL, 
	                 clase char(2)  NULL, 
	                 horario int NULL, 
	                 tiposal int NULL, 
	                 sueldo decimal(12, 2) NULL, 
	                 sindicato char(1)  NULL, 
	                 varia_imss decimal(8, 2) NULL, 
	                 centro char(15) NOT NULL, 
                  CONSTRAINT PK_plantilla_propuestos PRIMARY KEY CLUSTERED  
                 ( 
	                 empresa ASC, 
	                 idPlantilla ASC, 
	                 ocupacion ASC, 
	                 tipo ASC, 
	                 clave ASC, 
	                 centro ASC 
                 ) 
                 ) 
GO   

if not exists (select * from dbo.sysobjects 
                   where id = object_id(N'dbo.plantillas_vacanteContrata')
                   and OBJECTPROPERTY(id, N'IsUserTable') = 1)
                   CREATE TABLE dbo.plantillas_vacanteContrata( 
                     idempresa numeric(3, 0) NOT NULL,
                     usuario varchar(30)  NOT NULL,
                   CONSTRAINT PK_plantillas_vacanteContrata PRIMARY KEY CLUSTERED 
                  (
                     idempresa ASC,
                     usuario ASC
                  )
                  )
GO

if not exists (select * from dbo.sysobjects 
                   where id = object_id(N'dbo.plantillaConfiguracion')
                   and OBJECTPROPERTY(id, N'IsUserTable') = 1)
                  CREATE TABLE dbo.plantillaConfiguracion(
                     empresa numeric(3, 0) NOT NULL,
                    puedeVer char(1)  NULL,
                     propone char(1)  NULL,
                     autoriza char(1) NULL,
                     contrata char(1)  NULL,
                     diasaviso smallint NULL,
                   CONSTRAINT PK_plantilla_configuracion PRIMARY KEY CLUSTERED 
                  (
                     empresa ASC
                  ) 
                  ) 
GO

                 
if not exists (SELECT distinct(c.name)   
                  FROM dbo.SYSCOLUMNS C   
                  INNER JOIN dbo.SYSOBJECTS T    
                  ON C.ID = T.ID    
                  WHERE T.XTYPE = 'U'    
                  and t.name='plantillas'    
                  and c.name='mesinicio')   
ALTER TABLE  plantillas ADD mesinicio smallint NULL 
GO
              
if not exists (SELECT distinct(c.name)   
  FROM dbo.SYSCOLUMNS C    
  INNER JOIN dbo.SYSOBJECTS T    
  ON C.ID = T.ID    
  WHERE T.XTYPE = 'U'    
  and t.name='plantillas'    
  and c.name='diainicio')   
ALTER TABLE  plantillas ADD diainicio smallint NULL 
GO

if not exists (SELECT distinct(c.name)   
  FROM dbo.SYSCOLUMNS C    
  INNER JOIN dbo.SYSOBJECTS T    
  ON C.ID = T.ID    
  WHERE T.XTYPE = 'U'    
  and t.name='plantillas'    
  and c.name='mesfin')   
ALTER TABLE  plantillas ADD mesfin smallint NULL   
GO

if not exists (SELECT distinct(c.name)   
  FROM dbo.SYSCOLUMNS C    
 INNER JOIN dbo.SYSOBJECTS T    
  ON C.ID = T.ID    
  WHERE T.XTYPE = 'U'    
  and t.name='plantillas'    
  and c.name='diafin')    
ALTER TABLE  plantillas ADD diafin smallint NULL 
GO

 IF EXISTS(select syscolumns.name  from syscolumns 
                   left join sysobjects on syscolumns.id=sysobjects.id
                   where syscolumns.name = 'autorizada' and sysobjects.name='plantillas')
                   Alter table plantillas drop column autorizada
GO

 IF EXISTS(select syscolumns.name  from syscolumns 
                   left join sysobjects on syscolumns.id=sysobjects.id
                   where syscolumns.name = 'autorizada' and sysobjects.name='plantillas')
                   Alter table plantillas drop column autorizada
GO

 IF  EXISTS(select syscolumns.name  from syscolumns 
                   left join sysobjects on syscolumns.id=sysobjects.id 
                   where syscolumns.name = 'motivo' and sysobjects.name='plantillas')
                   Alter table plantillas drop column motivo
GO

 IF  EXISTS(select syscolumns.name  from syscolumns
                   left join sysobjects on syscolumns.id=sysobjects.id
                   where syscolumns.name = 'presupuesto_autorizado' and sysobjects.name='plantillas')
                   Alter table plantillas drop column presupuesto_autorizado
GO

 IF  EXISTS(select syscolumns.name  from syscolumns 
                   left join sysobjects on syscolumns.id=sysobjects.id 
                   where syscolumns.name = 'fecha_autorizada' and sysobjects.name='plantillas')
                   EXEC sp_rename 'plantillas.fecha_autorizada', 'fechainicio', 'COLUMN'
GO

 IF  EXISTS(select syscolumns.name  from syscolumns 
                   left join sysobjects on syscolumns.id=sysobjects.id
                   where syscolumns.name = 'fecha_termino' and sysobjects.name='plantillas')
                   EXEC sp_rename 'plantillas.fecha_termino', 'fechafinal', 'COLUMN' 
GO

IF not EXISTS(select syscolumns.name  from syscolumns 
               left join sysobjects on syscolumns.id=sysobjects.id
               where syscolumns.name = 'clase' and sysobjects.name='plantillas_puestos')
               Alter table plantillas_puestos add clase char(2)  
GO               

IF not EXISTS(select syscolumns.name  from syscolumns 
               left join sysobjects on syscolumns.id=sysobjects.id
               where syscolumns.name = 'horario' and sysobjects.name='plantillas_puestos')
               Alter table plantillas_puestos add horario int null  
GO               

IF not EXISTS(select syscolumns.name  from syscolumns 
               left join sysobjects on syscolumns.id=sysobjects.id
               where syscolumns.name = 'tiposal' and sysobjects.name='plantillas_puestos')
               Alter table plantillas_puestos add tiposal int null   
GO

IF not EXISTS(select syscolumns.name  from syscolumns 
               left join sysobjects on syscolumns.id=sysobjects.id
               where syscolumns.name = 'sueldo' and sysobjects.name='plantillas_puestos')
               Alter table plantillas_puestos add sueldo decimal(12,2)   
GO

IF not EXISTS(select syscolumns.name  from syscolumns 
               left join sysobjects on syscolumns.id=sysobjects.id
               where syscolumns.name = 'sindicato' and sysobjects.name='plantillas_puestos')
               Alter table plantillas_puestos add sindicato char(1)    
GO

IF not EXISTS(select syscolumns.name  from syscolumns 
               left join sysobjects on syscolumns.id=sysobjects.id
               where syscolumns.name = 'varia_imss' and sysobjects.name='plantillas_puestos')
               Alter table plantillas_puestos add varia_imss decimal(8,2) null   
GO

IF not EXISTS(select syscolumns.name  from syscolumns 
               left join sysobjects on syscolumns.id=sysobjects.id
               where syscolumns.name = 'reqAutorizacion' and sysobjects.name='plantillas_puestos')
               Alter table plantillas_puestos add reqAutorizacion char(1) null   
GO

IF not EXISTS(select syscolumns.name  from syscolumns 
               left join sysobjects on syscolumns.id=sysobjects.id
               where syscolumns.name = 'nivelAutorizacion' and sysobjects.name='plantillas_puestos')
               Alter table plantillas_puestos add nivelAutorizacion int null    
GO

IF not EXISTS(select syscolumns.name  from syscolumns 
               left join sysobjects on syscolumns.id=sysobjects.id
               where syscolumns.name = 'autorizador1' and sysobjects.name='plantillas_puestos')
               Alter table plantillas_puestos add autorizador1 varchar(50) null   
GO

IF not EXISTS(select syscolumns.name  from syscolumns 
               left join sysobjects on syscolumns.id=sysobjects.id
               where syscolumns.name = 'autorizador2' and sysobjects.name='plantillas_puestos')
               Alter table plantillas_puestos add autorizador2 varchar(50) null  
GO

IF not EXISTS(select syscolumns.name  from syscolumns 
               left join sysobjects on syscolumns.id=sysobjects.id
               where syscolumns.name = 'autorizador3' and sysobjects.name='plantillas_puestos')
               Alter table plantillas_puestos add autorizador3 varchar(50) null   
GO

IF not EXISTS(select syscolumns.name  from syscolumns 
               left join sysobjects on syscolumns.id=sysobjects.id
               where syscolumns.name = 'autorizador4' and sysobjects.name='plantillas_puestos')
               Alter table plantillas_puestos add autorizador4 varchar(50) null   
GO

IF not EXISTS(select syscolumns.name  from syscolumns 
               left join sysobjects on syscolumns.id=sysobjects.id
               where syscolumns.name = 'centro' and sysobjects.name='plantillas_puestos')
               Alter table plantillas_puestos add centro char(15) null    
GO

IF not EXISTS(select syscolumns.name  from syscolumns 
               left join sysobjects on syscolumns.id=sysobjects.id
               where syscolumns.name = 'tiponom' and sysobjects.name='plantillas_puestos')
               Alter table plantillas_puestos add tiponom int null    
GO

IF not EXISTS(select syscolumns.name  from syscolumns 
               left join sysobjects on syscolumns.id=sysobjects.id
               where syscolumns.name = 'email' and sysobjects.name='usuarios')
               Alter table usuarios add email varchar(250) null   
GO    

IF not  EXISTS(select syscolumns.name from syscolumns
               left join sysobjects on syscolumns.id=sysobjects.id
               where syscolumns.name = 'staffing' and sysobjects.name='plantillas')
               Alter table plantillas add staffing char(1) null

GO

              
update plantillas set staffing='N' where staffing is null                                                                                                                                           
GO                       

              
